summaryrefslogtreecommitdiffstats
path: root/client/shared/scripts/updateCache
diff options
context:
space:
mode:
Diffstat (limited to 'client/shared/scripts/updateCache')
-rwxr-xr-xclient/shared/scripts/updateCache78
1 files changed, 47 insertions, 31 deletions
diff --git a/client/shared/scripts/updateCache b/client/shared/scripts/updateCache
index bebb1153..2b7f2c3f 100755
--- a/client/shared/scripts/updateCache
+++ b/client/shared/scripts/updateCache
@@ -1,17 +1,29 @@
#!/bin/bash
-# Scirpt para la actualizacion de datos en la cache.
-# Versión: 0.9.1, 2008/03/17, - integracion eac
-# Versión: 0.9.2, 2010/07/27, - integracion opengnsys
-
-
-
-#1 REPO
-#2 nombre del fichero con su extension, tipo /imagen1.img o /ubuntu.iso
-#3 Protocolo TORRENT | MULTICAST | UNICAST
-#4 opciones protocolo
-#5 opciones de update cache
+#/**
+# updateCache
+#@brief Actualiza la cache del cliente con imagen o fichero iso.
+#@param 1 REPO Origen del fichero. -accesible por nfs-samba-
+#@param 2 str_fichero nombre del fichero a actualizar.
+#@param 3 str_protoco. TORRENT | MULTICAST | UNICAST.
+#@param 4 str_opcionesprotocolo
+#@param 4 str_opcionesupdatecache
+#@ejemplo: oneRemoteFromMaster 172.17.36.11 CACHE /imagen1 9000:full-duplex:239.194.17.36:70M:50:100 1 1 partclone lzop
+#@return
+#@exception OG_ERR_FORMAT formato incorrecto.
+#@note
+#@todo:
+#@version 0.9.1 - integracion EAC
+#@author Antonio J. Doblas Viso. Universidad de Malaga.
+#@date 2008/03/17
+#@version 0.9.2 - integracion OpenGnsys
+#@author Antonio J. Doblas Viso. Universidad de Malaga.
+#@date 2010/07/27
+#@version 1.0.1 - Control de espacio requerido
+#@author Antonio J.Doblas Viso
+#@date 2011-05-10
+#*/ ##
PROG="$(basename $0)"
if [ $# -lt 3 ]; then
@@ -19,9 +31,9 @@ if [ $# -lt 3 ]; then
exit $?
fi
-REPOSITORIO=$1
-PROTOCOLO=$3
-OPTPROTOCOLO=$4
+REPOSITORIO="$1"
+PROTOCOLO="$3"
+OPTPROTOCOLO="$4"
REPOIP=$(ogGetRepoIp)
echo $REPOSITORIO $REPOIP $PROTOCOLO $OPTPROTOCOLO
# Si el repositorio local CACHE no existe salimos.
@@ -39,7 +51,7 @@ ogUpdateCacheIsNecesary $1 $2; RETVAL=$?
CACHESIZEFREE=$(ogGetFreeSize `ogFindCache`)
-FILESIZE=$(ls -sk $(ogGetPath $1 $2) | cut -f1 -d" ")
+FILESIZE=$(ls -sk $(ogGetPath $REPOSITORIO "$2") | cut -f1 -d" ")
if [ "$FILESIZE" -ge "$CACHESIZEFREE" ]
then
@@ -48,32 +60,35 @@ then
exit $?
fi
-ogUpdateCacheIsNecesary $1 $2; RETVAL=$?
+ogUpdateCacheIsNecesary $REPOSITORIO "$2"; RETVAL=$?
# si RETVAL=0 => actualizamos si RETVAL=1 no actaulizasmo-exit 0 || si RETVAL>2 exit 1
[ "$RETVAL" == "1" ] && exit 0
[ "$RETVAL" -gt "1" ] && exit 1
-ogMountCache
+ogMountCache >/dev/null
## Si no existe, crear subdirectorio para el fichero en la cache.
-IMGDIR=$(ogGetParentPath "$1" "/$2")
+IMGDIR=$(ogGetParentPath CACHE "/$2")
if [ $? != 0 ]; then
echo "[5] Crear subdirectorio del fichero \"$2 $(dirname "$2")."
- ogMakeDir "CACHE" $(dirname "/$2")
- IMGDIR=$(ogGetParentPath "$1" "/$2") || exit $?
+ ogMakeDir CACHE $(dirname "/$2")
+ IMGDIR=$(ogGetParentPath CACHE "/$2") || exit $?
fi
-
-
case "$PROTOCOLO" in
torrent | TORRENT )
- echo "ogCopyFile $1 $2.torrent absolute $OGCAC$OGIMG"
- ogCopyFile $1 $2.torrent $OGCAC$OGIMG
+ echo "ogCopyFile $1 $2.torrent absolute $OGCAC/$OGIMG"
+ # tiempos
+ timewait=$(expr $(printf '%d\n' 0x$(ogGetMacAddress | awk -F: '{print $5$6}')) \* 120 / 65535)
+ ogCopyFile $REPOSITORIO "$2.torrent" "$IMGDIR"
#TODO: comprobar que el tracker definido en el fichero es correcto.
#TODO comprobar que el fichero torrent está en cache
- echo "ogTorrentStart CACHE $2.torrent $4"
- ogTorrentStart CACHE $2.torrent $4
+ # retardamos el inicio -aleatorio de 0 a 120 segundos- al tracker para gestionar mas de +-40 equipos
+ P2PWAIT=$[ ( $RANDOM % 120 ) + 1 ]
+ echo "Esperando $P2PWAIT segundos para iniciar ogTorrentStart CACHE $2.torrent $4"
+ sleep $P2PWAIT
+ ogTorrentStart CACHE "$2.torrent" $4
;;
multicast | MULTICAST )
echo "determinando puerto principal y auxiliar."
@@ -86,7 +101,7 @@ case "$PROTOCOLO" in
echo "comprobando puerto $PORTAUX en $REPOIP (sesion multicast en puerto $PORT) "
if (nmap -n -sU -p $PORTAUX $REPOIP | grep open)
then
- ogMcastReceiverFile $PORT CACHE $2
+ ogMcastReceiverFile $PORT CACHE "$2"
else
# TODO ticket 379 Realizar la petición basada en identificador de operacion
echo "solicita la apertura: hose $REPOIP 2009 --out sh -c "echo -ne START_MULTICAST $2 $OPTPROTOCOLO""
@@ -95,7 +110,7 @@ case "$PROTOCOLO" in
sleep 10
if (nmap -n -sU -p $PORTAUX $REPOIP | grep open)
then
- ogMcastReceiverFile $PORT CACHE $2
+ ogMcastReceiverFile $PORT CACHE "$2"
else
echo "la peticion ha fallado: hose $REPOIP 2009 --out sh -c echo -ne START_MULTICAST $2 $OPTPROTOCOLO"
exit 1
@@ -104,13 +119,14 @@ case "$PROTOCOLO" in
;;
unicast | UNICAST )
echo "unicast"
- ogCopyFile $1 $2 $OGCAC$OGIMG
+ ogCopyFile $REPOSITORIO "$2" "$IMGDIR"
;;
esac
-ogUpdateCacheIsNecesary $1 $2; RETVAL=$?
+ogUpdateCacheIsNecesary $REPOSITORIO "$2"; RETVAL=$?
# si RETVAL=0 => actualizamos si RETVAL=1 no actaulizasmo-exit 0 || si RETVAL>2 exit 1
[ "$RETVAL" == "0" ] && exit 1
[ "$RETVAL" == "1" ] && exit 0
-[ "$RETVAL" -gt "1" ] && exit 1 \ No newline at end of file
+[ "$RETVAL" -gt "1" ] && exit 1
+